// sStar = new starStar('xingxing',5,3,'../img/xing.png','../img/xing-1.png');
var starStar = (function() {

    function starStar(div, maxStar, minStar, norlStar, selStar, func) {
        this.initStarStar(div, maxStar, minStar, norlStar, selStar, func);
    }


    starStar.prototype = {
        maxStar : 5,
        starNum : 5,
        norlStar : '',
        selStar : '',
        func : null,
        initStarStar : function(div, maxStar, minStar, norlStar, selStar, func) {

            this.maxStar = maxStar;
            this.starNum = parseInt(minStar - 1);
            this.norlStar = norlStar;
            this.selStar = selStar;
            this.div = div;
            this.eleDiv = $('.' + div);
            this.func = func;
            this.isSel = true;

            this.setHtml();

        },
        setHtml : function() {
            var html = ''
            for (var i = 0; i < this.maxStar; i++) {
                var imgStr = this.norlStar;
                if (i <= this.starNum)
                    imgStr = this.selStar;
                html += '<div id="star_' + this.div + i + '"><img style="width:1.7em;height:1.7em;margin-right:.2em;" src="' + imgStr + '" /></div>'
            };
            this.eleDiv.html(html);
            //click
            for (var j = 0; j < this.maxStar; j++) {
                var obj = document.getElementById('star_' + this.div + j);
                obj.onclick = this.starClick.bind(this, obj);
            };
        },
        setStarStarSize : function(width,height) {
            for (var i = 0; i < this.maxStar; i++) {
                document.getElementById('star_'+this.div+i).children[0].style.width = width;
                document.getElementById('star_'+this.div+i).children[0].style.height = height;
            }
        },        
        getSelectStar : function() {
            var num = this.isSel ? parseInt(this.starNum + 1) : this.starNum;
            return num;
        },
        setSelectStar : function(starNum) {
            if (this.starNum != starNum) {
                this.starNum = starNum;
                this.isSel = true;
                for (var i = 0; i < this.maxStar; i++) {
                    var imgStr = this.norlStar;
                    if (i <= (parseInt(this.starNum))) imgStr = this.selStar;
                    document.getElementById('star_'+this.div+i).children[0].src = imgStr;
                }
            }
        },
        starClick : function(ele) {
            var index = $(ele).index();
            if (this.func) this.func(this.starNum);
            this.setSelectStar(index);
        }
    }

    return starStar;

})();

