//获取数据
function getDataByAjax(url, dataObj, type, fn) {
    var getUrl = globalUrl + url;
    $.ajax({
        type: type,
        url: getUrl,
        cache:false,
        async: false,
        success: fn,
        dataType: 'json',
        data: dataObj,
        beforeSend:function() {
        },
        error:function(err) {
           // appcan.window.openToast('获取数据失败', 1000, 5, 0);
        },
        complete: function(){
        }
    });
}

//打开新窗口
function openNewWin(name, url) {
    appcan.openWinWithUrl(name, url);
}

//关闭页面   
function toClose() {
    appcan.window.close(-1);
}

//设置缓存
function setLocVal(key, value) {
    window.localStorage[key] = value;
}

//获取缓存
function getLocVal(key) {
    if (window.localStorage[key])
        return window.localStorage[key];
    else
        return "";
}

//清空缓存
function clearLocVal(key){
    if(key)
        window.localStorage.removeItem(key);
    else
        window.localStorage.clear();
}

//获取id元素
function $$(id) {
    return document.getElementById(id)
}

//排序
function ksort(inputArr, sort_flags) {
      var tmp_arr = {},
        keys = [],
        sorter, i, k, that = this,
        strictForIn = false,
        populateArr = {};
    
      switch (sort_flags) {
      case 'SORT_STRING':
        // compare items as strings
        sorter = function (a, b) {
          return that.strnatcmp(a, b);
        };
        break;
      case 'SORT_LOCALE_STRING':
        // compare items as strings, original by the current locale (set with  i18n_loc_set_default() as of PHP6)
        var loc = this.i18n_loc_get_default();
        sorter = this.php_js.i18nLocales[loc].sorting;
        break;
      case 'SORT_NUMERIC':
        // compare items numerically
        sorter = function (a, b) {
          return ((a + 0) - (b + 0));
        };
        break;
        // case 'SORT_REGULAR': // compare items normally (don't change types)
      default:
        sorter = function (a, b) {
          var aFloat = parseFloat(a),
            bFloat = parseFloat(b),
            aNumeric = aFloat + '' === a,
            bNumeric = bFloat + '' === b;
          if (aNumeric && bNumeric) {
            return aFloat > bFloat ? 1 : aFloat < bFloat ? -1 : 0;
          } else if (aNumeric && !bNumeric) {
            return 1;
          } else if (!aNumeric && bNumeric) {
            return -1;
          }
          return a > b ? 1 : a < b ? -1 : 0;
        };
        break;
      }
    
      // Make a list of key names
      for (k in inputArr) {
        if (inputArr.hasOwnProperty(k)) {
          keys.push(k);
        }
      }
      keys.sort(sorter);
    
      // BEGIN REDUNDANT
      this.php_js = this.php_js || {};
      this.php_js.ini = this.php_js.ini || {};
      // END REDUNDANT
      strictForIn = this.php_js.ini['phpjs.strictForIn'] && this.php_js.ini['phpjs.strictForIn'].local_value && this.php_js
        .ini['phpjs.strictForIn'].local_value !== 'off';
      populateArr = strictForIn ? inputArr : populateArr;
    
      // Rebuild array with sorted key names
      for (i = 0; i < keys.length; i++) {
        k = keys[i];
        tmp_arr[k] = inputArr[k];
        if (strictForIn) {
          delete inputArr[k];
        }
      }
      for (i in tmp_arr) {
        if (tmp_arr.hasOwnProperty(i)) {
          populateArr[i] = tmp_arr[i];
        }
      }
    
      return strictForIn || populateArr;
    }
        
/**
 * 生成签名信息
 * $secretKey 产品私钥
 * $params 接口请求参数，不包括signature参数
 */
function gen_signature(params, secretKey){
    d = ksort(params);
    buff="";
    $.each(d, function(key, value){ 
        buff +=key+'=';
        buff +=value+'&';

    });
    buff += 'key='+secretKey;
    return md5(buff).toUpperCase();
}

//设置别名
function setAlias() {
    var json = {
        alias: getLocVal("user_id"),
    };
    uexJPush.setAlias(json, function(error,data) {
       if(!error){
          //  alert(JSON.stringify(data));
       }else{
          //  alert("设置失败");
       }
    });
}

//设置标签
function setTags() {
    var tags = new Array();
    if(getLocVal("user_type") == '1') {  //个人用户
        tags.push('gr');
        tags.push('gr_'+getLocVal("region"));
    } else if(getLocVal("user_type") == '2') {  //中介用户
        tags.push('zj');
        tags.push('zj_'+getLocVal("region"));
    } else if(getLocVal("user_type") == '3') {  //企业用户
        tags.push('qy');
        tags.push('qy_'+getLocVal("region"));
    }
    
    var json = {
        tags:tags
    };
    uexJPush.setTags(json, function(error,data) {
       if(!error){
           // alert(JSON.stringify(data));
       }else {
          //  alert("设置失败");
       }
    });
}

//去掉alert域名
(function(){
    window.alert = function(name){
        var iframe = document.createElement("IFRAME");
        iframe.style.display="none";
        iframe.setAttribute("src", 'data:text/plain');
        document.documentElement.appendChild(iframe);
        window.frames[0].window.alert(name);
        iframe.parentNode.removeChild(iframe);
    }
})();

//打开图片
function openImg(url) {
    var imgArray = new Array();
    imgArray.push(url);
    var data = {
        startIndex:0,
        data:imgArray
    }
    uexImage.openBrowser(data,function(){
    });
}

//退出登录
function loginOut() {
    clearLocVal("login_if");
    clearLocVal("phone");
    clearLocVal("user_id");
    clearLocVal("user_name");
    clearLocVal("user_type");
    clearLocVal("region");
    clearLocVal("head_img");
    
    var json = {
       name: ''
    }
    uexWindow.publishChannelNotification("changeUserName",JSON.stringify(json));
    
    setAlias(); //设置别名
    setTags(); //设置标签
}
