	var $support = {
		transform3d: ('WebKitCSSMatrix' in window),
		touch: ('ontouchstart' in window)
	};

	var $E = {
		start: $support.touch ? 'touchstart' : 'mousedown',
		move: $support.touch ? 'touchmove' : 'mousemove',
		end: $support.touch ? 'touchend' : 'mouseup',
		cancel: $support.touch ? 'touchcancel' : '',
		transEnd:'webkitTransitionEnd'
	};
	function getPage (event, page) {
		return $support.touch ? event.changedTouches[0][page] : event[page];
	}
	var zyEvent = function(selector,lock,transEnd,click){
		var self = this;
		var max = 50;
		self.Max = {X:max,Y:max};
		self.transEnd = transEnd||null;
        self.click = click||null;
		self.type = "";
		self._vendor=(window.navigator.userAgent.indexOf("Android 4.")>=0);
		self._locked=lock;
		self.start = false;
		if(typeof selector == 'object') self.element = selector;
		else if(typeof selector == 'string') self.element = document.getElementById(selector);
		self.element.addEventListener($E.start, self, false);
		self.element.addEventListener($E.move, self, false);
        self.element.addEventListener($E.end, self, false);
		//self.element.addEventListener($E.transEnd, self, false);
		//self.element.addEventListener("click",self,false); 
	//	document.addEventListener($E.start, self, false);

		return self;
	}

	zyEvent.prototype = {
		handleEvent: function(event) {
			var self = this;
			
			switch (event.type) {
				case $E.start:
				    console.log('touch start');
					self._touchStart(event);
					break;
				case $E.move:
					self._touchMove(event);
					break;
				case $E.end:
					self._touchEnd(event);
					break;
				case 'click':
					self._click(event);
					break;
			}
		},
        _touchStart: function(event) {
        	
            var self = this;
            self.start = true;
            
            if(!$support.touch) event.preventDefault();
            if(self._locked){
                if(event.stopPropagation) event.stopPropagation();
                else                      event.cancelBubble = true;
            }
            
			self.type = "";
            self.startPageX = getPage(event, 'pageX');
            self.startPageY = getPage(event, 'pageY');
            
            //self.element.style.left = self.startPageX-self.element.offsetWidth/2+'px';
            //self.element.style.top = self.startPageY-self.element.offsetHeight/2+'px';
            self.type = 'touchstart'
            self.startTime = event.timeStamp;
        },
        _touchMove: function(event) {
        	
            var self = this;
			if(!self.start) return;
			
			if(self._locked){
                event.preventDefault();
                if(event.stopPropagation) event.stopPropagation();
                else                      event.cancelBubble = true;
           }
				
            var pageX = getPage(event, 'pageX'),
                pageY = getPage(event, 'pageY'),
                deltaX = pageX - self.startPageX,
                deltaY = pageY - self.startPageY;
			
				
		   if(self._vendor)//Android 4.0 need prevent default
		   {
		   		if(deltaY>-10&&deltaY<10){
					if(deltaY<-0||deltaY>0){
						event.preventDefault();
					}
				}
		   }
			
			if(Math.abs(deltaX)>10 || Math.abs(deltaY)>10 ){
                console.log('touch move');
                self.type = 'touchsmove';
			}
			
			if(self.type == 'touchsmove'){
                if(self.moveFun) self.moveFun(self.element,pageX,pageY);
                var left = pageX-self.element.offsetWidth/2;
                var top = pageY-self.element.offsetHeight/2;
                $(self.element).css({left:left,top:top});
                //self.element.style.left = pageX-self.element.offsetWidth/2+'px';
                //self.element.style.top = pageY-self.element.offsetHeight/2+'px';
			}

        },
        _touchEnd: function(event) {
            
            var self = this;
            if(self.start == true)
            {
                console.log('touch end');
                
                if(self._locked){
                    event.preventDefault();
                    if(event.stopPropagation) event.stopPropagation();
                    else                      event.cancelBubble = true;
                }
                
            	var pageX = getPage(event, 'pageX'),
                    pageY = getPage(event, 'pageY'),
                    deltaX = pageX - self.startPageX,
                    deltaY = pageY - self.startPageY;
            	
            	if(self.type == 'touchstart'){
            	    if(self.click) self.click(self.element);
            	}else{
            	     //self.element.style.left = pageX-self.element.offsetWidth/2+'px';
                     //self.element.style.top = pageY-self.element.offsetHeight/2+'px';
                    var left = pageX-self.element.offsetWidth/2;
                    var top = pageY-self.element.offsetHeight/2;
                    $(self.element).css({left:left,top:top});
                     
            	    if(self.endFun) self.endFun(self.element,pageX,pageY);
            	}
            	
                this.type = 'touchsend'
            	self.start = false;
            	
            	if(self.transEnd) self.transEnd(self.element);
            }
            
        },
        _click: function(event) {
            var self = this;
            
            event.preventDefault();
            if(event.stopPropagation) event.stopPropagation();
            else                      event.cancelBubble = true;
            
            if(self.type!='touchsmove'){
                console.log('touch click');
                self.type = 'click'
                self.start = false;
                if(self.click) self.click(self.element);
            }
        },
        destroy: function() {
            var self = this;

            self.element.removeEventListener($E.start, self);
            self.element.removeEventListener($E.move, self);
            //self.element.removeEventListener($E.transEnd, self);
            self.element.removeEventListener('click', self);
            self.element.removeEventListener($E.cancel, self);
            self.element.removeEventListener($E.end, self);
            //document.removeEventListener($E.cancel, self);
        }
	}


